;
;	FANTIC [`
;
	ORG	2000h

CUR_DOWN	EQU	11h
CUR_UP		EQU	12h
CUR_RIGHT	EQU	13h
CUR_LEFT	EQU	14h
SHIFT_BREAK	EQU	64h

CURSOR_CHR	EQU	0CDh
CURSOR_ATTR	EQU	50h

VRAMADDR	EQU	0D400h

FanticBin:
	BINCLUDE "FANTIC1500.BIN"

;;; 790Ah ;;;

	JP	GPut			; 790Ah: 2x2PCG`
	JP	Locate			; 790Dh: GPRINT̍Wݒ
	JP	Color			; 7910h: GPRINT̃J[ݒ
	JP	GPrint			; 7913h: `
	JP	Gauge			; 7916h: Q[W`
	JP	GPrintNum		; 7919h: l`
	JP	Sound			; 791Ch: TEhĐ
	JP	Wait			; 791Fh: EFCg
	JP	Inkey			; 7922h: Q[L[
	JP	OptionScreen		; 7925h: ݒ

ColorTable:	;0    1     2    3    4    5    6    7
	DB	08h, 08h, 0C8h, 08h, 08h, 88h, 48h, 08h

Entry:
	DI
	LD	SP, FanticBin

	;
	; VRAM
	;
	LD	HL, 0D000h
	LD	DE, 0D001h
	LD	BC, 800h
	LD	(HL), L
	LDIR
	LD	BC, 999
	LD	(HL), 70h
	LDIR

	;
	; PCG`
	;
	LD	HL, FanticBin
	LD	DE, 0D000h
	LD	BC, 800h

	LD	A, 1			; BLUE
	OUT	(0E5h), A
	PUSH	BC
	PUSH	DE
	LDIR
	POP	DE
	POP	BC

	INC	A			; RED
	OUT	(0E5h), A
	PUSH	BC
	PUSH	DE
	LDIR
	POP	DE
	POP	BC

	INC	A			; GREEN
	OUT	(0E5h), A
	LDIR

	;
	; ̐FႢp^[`
	;
	CALL	InitLetterPCG
	CALL	AddLetterPCG

	;
	; Q[WPCG`
	;
	CALL	InitGaugePCG
	CALL	DrawGauge

	OUT	(0E6h), A

	;
	; Q[ʂ̘g`
	;
	LD	HL, 0D400h
	LD	DE, 0DC00h
	CALL	DrawFrameFilled
	CALL	DrawFrameOdd
	CALL	DrawFrameFilled
	LD	B, 10
@@:	PUSH	BC
	CALL	DrawFrameOdd
	CALL	DrawFrameEven
	POP	BC
	DJNZ	@b
	LD	C, 0B0h
	CALL	DrawFrameGauge
	LD	C, 0B1h
	CALL	DrawFrameGauge

	LD	A, 4Fh
	CALL	DrawCenterMark

	LD	HL, Mes
	CALL	PrintStrings

	;
	; pbgݒ
	;
	LD	A, 88h
@@:	SUB	11h
	OUT	(0F1h), A
	JR	NZ, @b

	;
	; PCG ON
	;
;;;	LD	A, 1		; TEXT FG > PCG > TEXT BG
	LD	A, 3		; PCG > TEXT
	OUT	(0F0h), A

	;
	; WCXeBbNڑ`FbN
	;
	CALL	CheckJoy1
	JR	NC, @f
	LD	HL, 001Bh	; ڑĂȂ΁AROM GETKY ĂԂɂ
	LD	(7923h), HL
@@:
;;;JP OptionScreen
	;
	; CoCiɔ
	;
	JP	8000h

;
; PCG (30h-5Ah) ̐FႢp^[pӂ
;
InitLetterPCG:
	LD	DE, 0D800h + 30h * 8
	LD	C, 6			; F
	CALL	InitLetterPCG_Sub
	LD	DE, 0E000h + 30h * 8
	LD	C, 5			; F
	CALL	InitLetterPCG_Sub
	LD	DE, 0E800h + 30h * 8
	LD	C, 2			; 
	;;;fallthru;;;
InitLetterPCG_Sub:
	LD	B, 3			; 3v[[v
@3:	LD	A, 4
	SUB	B
	OUT	(0E5h), A
	RR	C
	PUSH	BC
	PUSH	DE
	JR	NC, @1f
	;
	; Rs[
	;
	LD	HL, 0D000h + 30h * 8
	LD	BC, 8*2Bh
	LDIR
@2:	POP	DE
	POP	BC
	DJNZ	@3b
	RET
	;
	; [NA
	;
@1:	EX	DE, HL
	XOR	A
@@:	LD	(HL), A
	CPI
	JP	PE, @b
	JR	@2b

;
; ȂPCG̃p^[pӂ
;
; PCG1ɖEn[g̔`
;
MojiBuf	EQU	11A3h
AddLetterPCG:
	LD	DE, @7f

@2:	LD	A, (DE)			; 700̃fBXvCR[h
	OR	A
	RET	Z
	INC	DE
	LD	H, 0D0h >> 3
	LD	L, A
	ADD	HL, HL
	ADD	HL, HL
	ADD	HL, HL

	XOR	A
	OUT	(0E5h), A		; CGROMobt@ɃRs[
	PUSH	DE
	LD	DE, MojiBuf
	LD	BC, 8
	LDIR
	POP	DE

@1:	LD	A, (DE)			; PCGR[h
	INC	DE
	PUSH	DE

	LD	H, 0D8h >> 3
	LD	L, A
	ADD	HL, HL
	ADD	HL, HL
	ADD	HL, HL
	EX	DE, HL
	LD	HL, MojiBuf

	LD	A, 1
@@:	OUT	(0E5h), A
	LD	C, 8
	PUSH	HL
	PUSH	DE
	LDIR
	POP	DE
	POP	HL
	INC	A
	CP	4
	JR	C, @b

	POP	DE
	JR	@2b

	;	700	2000
@7:	DB	80h,	81h		; 
	DB	50h,	82h		; 
	DB	40h,	83h		; 
	DB	45h,	84h		; 
	DB	53h,	86h		; n[g
	DB	00h

;
; Q[WPCGpӂ
;
InitGaugePCG:
	LD	A, 1			; BLUE
	CALL	@1f
	LD	A, 2			; RED
	CALL	@1f
	LD	A, 3			; GREEN
	;;;fallthru;;;
@1:	OUT	(0E5h), A
	LD	A, 80
	LD	DE, 0D800h + 0B0h * 8
@@:	LD	HL, 0D000h + 5Bh * 8
	LD	C, 8
	LDIR
	DEC	A
	JR	NZ, @b
	RET

DrawGauge:
	;
	; [
	;
	LD	HL, 0D800h + 8*0B2h + 4
	LD	B, 7
@@:	LD	A, 1
	OUT	(0E5h), A
	SET	0, (HL)
	LD	A, 2
	OUT	(0E5h), A
	SET	0, (HL)
	LD	A, 3
	OUT	(0E5h), A
	SET	0, (HL)
	INC	HL
	DJNZ	@b
	;
	; 
	;
	LD	HL, 0D800h + 8*0B4h + 4
	LD	D, 36
@1:	LD	BC, 0741h
@@:	RR	C
	SBC	A, A
	LD	E, A
	LD	A, 1
	OUT	(0E5h), A
	LD	(HL), E
	LD	A, 2
	OUT	(0E5h), A
	LD	(HL), 0FFh
	LD	A, 3
	OUT	(0E5h), A
	LD	(HL), E
	INC	HL
	DJNZ	@b
	LD	C, 9
	ADD	HL, BC
	DEC	D
	JR	NZ, @1b
	;
	; E[
	;
	LD	B, 7
@@:	LD	A, 1
	OUT	(0E5h), A
	SET	7, (HL)
	LD	A, 2
	OUT	(0E5h), A
	SET	7, (HL)
	LD	A, 3
	OUT	(0E5h), A
	SET	7, (HL)
	INC	HL
	DJNZ	@b

	RET

;
; g`Tu[`
;
DrawFrameFilled:
	LD	A, 08h
	LD	B, 20
@@:	LD	(HL), 5Bh
	INC	HL
	LD	(HL), 5Ch
	INC	HL
	LD	(DE), A
	INC	DE
	LD	(DE), A
	INC	DE
	DJNZ	@b
	RET

DrawFrameOdd:
	LD	C, 5Dh
	JR	@f
DrawFrameEven:
	LD	C, 5Bh
@@:	LD	A, 08h
	CALL	@1f

	LD	B, 36
@@:	LD	(HL), 0FFh
	LD	(DE), A
	INC	HL
	INC	DE
	DJNZ	@b

@1:	LD	(HL), 5Bh
	INC	HL
	LD	(HL), 5Ch
	INC	HL
	LD	(DE), A
	INC	DE
	LD	(DE), A
	INC	DE
	RET

DrawFrameGauge:
	LD	A, 48h
	LD	B, 40
@@:	LD	(HL), C
	LD	(DE), A
	INC	HL
	INC	DE
	INC	C
	INC	C
	DJNZ	@b
	RET

;
; FubNGA`
;
DrawCenterMark:
	LD	HL, 0D000h + 18 + 11*40
	LD	D, 4
@1:	LD	BC, (4 << 8) | (40-4)
@@:	LD	(HL), A
	INC	HL
	DJNZ	@b
	ADD	HL, BC
	DEC	D
	JR	NZ, @1b
	RET

;
; `
;
PrintStrings:
@@:	LD	C, (HL)
	INC	C
	DEC	C
	RET	Z
	INC	HL
	LD	D, (HL)
	INC	HL
	LD	E, (HL)
	INC	HL
	CALL	PrintString
	JR	@b

PrintString:			; IN : HL = AhX  DE = VRAMAhX  C = Agr[g
@@:	LD	A, (HL)
	INC	HL
	OR	A
	RET	Z
	LD	(DE), A
	SET	3, D
	LD	A, C
	LD	(DE), A
	RES	3, D
	INC	DE
	JR	@b

Mes:
Mes_Score:	DB	0C8h, 0D4h, 40 +  3, "SCORE", 0
Mes_Top:	DB	0C8h, 0D4h, 40 + 15, "TOP", 0
Mes_Round:	DB	048h, 0D4h, 40 + 25, "ROUND", 0
Mes_Ticun:	DB	008h, 0D4h, 40 + 34, 0CDh, 0
Mes_00:		DB	008h, 0D4h, 40 + 12, "00", 0
Mes_5000:	DB	008h, 0D4h, 40 + 20, "5000", 0
Mes_1:		DB	008h, 0D4h, 40 + 32, "1", 0
;;;Mes_Test:	DB	048h, 0D4h, 7Ah, 7Eh, 81h, 82h, 83h, 84h, 86h, "@@@", 0
Mes_0:		DB	008h, 0D4h, 40 + 36, "0", 0
		DB	0

;------------------------------------------------------------------------------
; VRAMAhXvZ
; IN :	H = XW (0-39)
;	L = YW (0-24)
; OUT:	HL = VRAMAhX
; DES:	BC, DE
;------------------------------------------------------------------------------
CalcVRAMAddr:
	LD	E, H
	LD	H, 0
	ADD	HL, HL		; x2
	ADD	HL, HL		; x4
	ADD	HL, HL		; x8
	LD	B, H
	LD	C, L
	ADD	HL, HL		; x16
	ADD	HL, HL		; x32
	ADD	HL, BC		; x40
	LD	D, 0D4h
	ADD	HL, DE		; HL = 0D400h + X + Y*40
	RET

;------------------------------------------------------------------------------
; HL10i5ASCIIɕϊ(EOS:00h)
; [TvXȂ
;  IN :	HL = l(0-65535)
;  OUT:	(DE) = ϊ
;  DES: AF,BC,DE,HL
;------------------------------------------------------------------------------
HL2Dec:
	XOR	A		; CDE = 5BCD
	LD	D, A
	ADD	HL, HL		; 3rbg͕␳ȂOK
	RLA
	ADD	HL, HL
	RLA
	ADD	HL, HL
	RLA
	LD	E, A
	LD	B, 16-3		; c13rbg

@@:	ADC	HL, HL		; l̏ʃrbgoA10,000̌Ƀrbg荞
	LD	A, E		; BCD X = X * 2 + Cy vZ
	ADC	A, A
	DAA
	LD	E, A
	LD	A, D
	ADC	A, A
	DAA
	LD	D, A
	DJNZ	@b
	LD	A, L		; 10,000̌ɍŌ̃rbg荞
	ADC	A, A

	LD	HL, DecBuf
	ADD	A, '0'		; ŏ(10,000̈)
	LD	(HL), A
	INC	HL
	LD	(HL), D		; 1,000̈
	CALL	@f		; 100̈
	LD	(HL), E		; 10̈
@@:	LD	A, 33h
	RRD
	INC	HL
	LD	(HL), A		; 1̈
	INC	HL
	LD	(HL), 0

	RET

DecBuf:	DS	6

Mes_000	EQU	DecBuf + 2
R100	EQU	Mes_000
R10	EQU	Mes_000 + 1
R1	EQU	Mes_000 + 2

;------------------------------------------------------------------------------
; GPUT	2x2̃p^[`
; IN :	H = XW (0-39)
;	L = YW (0-24)
;	A = p^[ԍ擪 (0FFh̏ꍇׂ͂0FFhŕ`)
;------------------------------------------------------------------------------
GPut:
	CALL	CalcVRAMAddr
	LD	BC, 40-1
	CP	0FFh
	JR	Z, @f

	LD	(HL), A
	INC	HL
	INC	A
	LD	(HL), A
	ADD	HL, BC
	INC	A
	LD	(HL), A
	INC	HL
	INC	A
	LD	(HL), A

	RET

@@:	LD	(HL), A
	INC	HL
	LD	(HL), A
	ADD	HL, BC
	LD	(HL), A
	INC	HL
	LD	(HL), A
	RET

;------------------------------------------------------------------------------
; GPrint `
; IN :	HL = AhX
;------------------------------------------------------------------------------
GPrint:
CurrentColor EQU $+1
	LD	C, 08h
CurrentVRAMAddr EQU $+1
	LD	DE, 0D400h
	CALL	PrintString
	LD	(CurrentVRAMAddr), DE
	RET

;------------------------------------------------------------------------------
; GPrintNum l`
; IN :	HL = `悷鐔l
;	C  = (1-5)
;------------------------------------------------------------------------------
GPrintNum:
	PUSH	BC
	CALL	HL2Dec

	LD	HL, DecBuf
	LD	B, 4
@@:	LD	A, (HL)
	CP	'0'
	JR	NZ, @f
	LD	(HL), '@'
	INC	HL
	DJNZ	@b

@@:	POP	BC
	LD	B, 0
	LD	HL, DecBuf+5
	OR	A
	SBC	HL, BC
	JR	GPrint

;------------------------------------------------------------------------------
; LOCATE JgVRAMAhXύX
; IN :	H = XW (0-39)
;	L = YW (0-24)
;------------------------------------------------------------------------------
Locate:
	CALL	CalcVRAMAddr
	LD	(CurrentVRAMAddr), HL
	RET

;------------------------------------------------------------------------------
; COLOR JgJ[ύX
; IN :	A = J[
;------------------------------------------------------------------------------
Color:
	LD	H, ColorTable >> 8
	ADD	A, ColorTable
	LD	L, A
	LD	A, (HL)
	LD	(CurrentColor), A
	RET

;------------------------------------------------------------------------------
; GAUGE Q[W1hbg`
; IN :	HL = Q[WXW (0-319)	H = 0FFh ̂Ƃ͑ŜԂœhԂ
;	C  = J[
;------------------------------------------------------------------------------
Gauge:
	BIT	7, H
	JR	NZ, GaugeFill

	LD	A, L
	CPL
	AND	07h
	ADD	A, A
	ADD	A, A
	ADD	A, A
	OR	86h
	LD	E, A
	RR	C
	SBC	A, A
	AND	40h		; SET b,(HL)	CB (C6 | (b << 3))
	OR	E		; RES b,(HL)	CB (86 | (b << 3))
	LD	(@1f+1), A
	RR	C
	SBC	A, A
	AND	40h
	OR	E
	LD	(@2f+1), A
	RR	C
	SBC	A, A
	AND	40h
	OR	E
	LD	(@3f+1), A

	LD	A, L
	AND	0F8h
	LD	L, A
	ADD	HL, HL
	LD	DE, 0D800h + 0B0h*8 + 5
	ADD	HL, DE

	LD	A, 1
	OUT	(0E5h), A
	LD	B, 5
	PUSH	HL
@1:	SET	0, (HL)
	INC	HL
	DJNZ	@1b
	POP	HL

	INC	A
	OUT	(0E5h), A
	LD	B, 5
	PUSH	HL
@2:	SET	0, (HL)
	INC	HL
	DJNZ	@2b
	POP	HL

	INC	A
	OUT	(0E5h), A
	LD	B, 5
@3:	SET	0, (HL)
	INC	HL
	DJNZ	@3b

@9:	OUT	(0E6h), A
	RET

GaugeFill:
	LD	HL, 0D800h + 0B4h*8 + 5
	LD	C, 11
	LD	DE, (36 << 8) | 0

@1:	LD	A, 1
	OUT	(0E5h), A
	LD	B, 5
	PUSH	HL
@@:	LD	(HL), E
	INC	HL
	DJNZ	@b
	POP	HL

	INC	A
	OUT	(0E5h), A
	LD	B, 5
	PUSH	HL
@@:	LD	(HL), 0FFh
	INC	HL
	DJNZ	@b
	POP	HL

	INC	A
	OUT	(0E5h), A
	LD	B, 5
@@:	LD	(HL), E
	INC	HL
	DJNZ	@b

	ADD	HL, BC
	DEC	D
	JR	NZ, @1b

	JR	@9b

;------------------------------------------------------------------------------
; SOUND TEhĐ
; IN :	HL =  (f = 1 / HL * 13us)
;	BC = Đ钷
;------------------------------------------------------------------------------
Sound:
	PUSH	HL
	ADD	HL, HL		; x2
	ADD	HL, HL		; x4
	LD	E, L
	LD	D, H
	ADD	HL, HL		; x8
	ADD	HL, DE		; x12
	EX	DE, HL
	LD	HL, 0E007h
	LD	(HL), 00_11_011_0b	; Ch.0, L->H, Mode 3, Binary
	LD	L, 04h			; Ch.0
	LD	(HL), E
	LD	(HL), D
	LD	L, 08h
	LD	(HL), 1		; GATE = 1
	POP	HL

@1:	LD	D, H
	LD	E, L
@@:	DEC	DE		;  6 ( 6) 13us̃fBC
	LD	A, D		;  4 (10)
	OR	E		;  4 (14)
	PUSH	HL		; 11 (25)
	POP	HL		; 10 (35)
	JR	NZ, @b		; 12 (27)
	DEC	BC
	LD	A, B
	OR	C
	JR	NZ, @1b

	LD	(0E008h), A	; GATE = 0

	RET

;------------------------------------------------------------------------------
; WAIT 1msPʂ̃EFCg
; IN :	HL = EFCg̒(ms)
;------------------------------------------------------------------------------
@1:	LD	B, 17		; (   7:    7)
@@:	DJNZ	@b		; ( 216:  223)
@@:	DJNZ	@b		; (3323: 3546)
	DEC	HL		; (   6: 3552)	HL--
Wait:
	LD	B, A		; (   4: 3556)	Aۑ
	LD	A, H		; (   4: 3560)	HL == 0 ?
	OR	L		; (   4: 3564)
	LD	A, B		; (   4: 3568)	AA
	JR	NZ, @1b		; (  12: 3580)
	RET

;------------------------------------------------------------------------------
; INKEY Q[L[
; OUT:	A = L[f[^
;------------------------------------------------------------------------------
Inkey:
	CALL	ReadJoyPort1
	CP	0FFh
	JP	Z, 001Bh
	LD	HL, @7f
	LD	C, A
@@:	LD	A, (HL)
	RR	C
	RET	NC
	INC	HL
	JR	@b

@7:	DB	' '		; A button
	DB	' '		; B button
	DB	CUR_LEFT	; Left
	DB	CUR_RIGHT	; Right
	DB	CUR_DOWN	; Down
	DB	CUR_UP		; Up
	DB	' '		; RUN button
	DB	SHIFT_BREAK	; SELECT button

;------------------------------------------------------------------------------

;==============================================================================
;	OPTION
;==============================================================================
OptionScreen:
	PUSH	DE		; GAME MODE̕Ԓl|C^
	PUSH	HL		; ROUND̕Ԓl|C^

	LD	E, (HL)
	INC	HL
	LD	D, (HL)
	EX	DE, HL
	CALL	HL2Dec

	XOR	A
	CALL	DrawCenterMark
	;
	; Œ胁bZ[W̕\
	;
	LD	HL, Mes_Option
	CALL	PrintStrings

	LD	A, 7
	CALL	Color
	CALL	Print_Round
	CALL	Print_GameMode

	CALL	Operate_Options

	;
	; ASCII 10i3  oCil ϊ
	;
	LD	HL, R100
	LD	A, (HL)		; 100̌
	INC	HL
	SUB	30h-1		; '0'1 '1'2 ... '3'4
	LD	B, A		; [vJE^
	LD	A, (HL)		; 10̌
	INC	HL
	AND	0Fh
	ADD	A, A		; x2
	LD	C, A
	ADD	A, A		; x4
	ADD	A, A		; x8
	ADD	A, C		; x10
	LD	C, A
	LD	A, (HL)		; 1̌
	AND	0Fh
	ADD	A, C
	LD	C, 0FFh		; 1񑽂[v̂
	SUB	100		; 炩 100 Ă
@1:	ADD	A, 100
	JR	NC, @2f
	INC	C
@2:	DJNZ	@1b

	POP	HL		; ROUND̕Ԓl|C^
	LD	(HL), A		; ROUND
	INC	HL
	LD	(HL), C		; ROUND

	POP	DE
	LD	A, (GameMode)
	LD	(DE), A

	LD	A, 4Fh
	JP	DrawCenterMark

;------------------------------------------------------------------------------
;	OPTION
;------------------------------------------------------------------------------
Cursor_on_GameMode:				; GAME MODE
	LD	(HL), 0FFh
	LD	HL, VRAMADDR + 4 + 11*40
	LD	(HL), CURSOR_CHR
@@:	CALL	KeyIn
	CP	CUR_UP
	JR	Z, Cursor_on_RoundSel
	CP	CUR_DOWN
	JR	Z, Cursor_on_Exit
	CP	' '
	JR	Z, @1f
	CP	CUR_RIGHT
@1:	CALL	Z, Inc_GameMode
	CP	CUR_LEFT
	CALL	Z, Dec_GameMode
	JR	@b

Cursor_on_Exit:					; EXIT
	LD	(HL), 0FFh
	LD	HL, VRAMADDR + 16 + 19*40
	LD	(HL), CURSOR_CHR
@@:	CALL	KeyIn
	CP	CUR_UP
	JR	Z, Cursor_on_GameMode
	CP	' '
	JR	NZ, @b
	RET

Cursor_on_RoundSel:				; ROUND TO START
	LD	(HL), 0FFh
Operate_Options:
	LD	HL, VRAMADDR + 4 + 8*40
	LD	(HL), CURSOR_CHR
@@:	CALL	KeyIn
	CP	CUR_DOWN
	JR	Z, Cursor_on_GameMode
	CP	CUR_RIGHT
	JR	Z, Cursor_on_R100
	JR	@b

Cursor_on_R100:					; EhZNg 100̈
	LD	(HL), 0FFh
	LD	HL, VRAMADDR + 25 + 9*40
	LD	(HL), CURSOR_CHR
@@:	CALL	KeyIn
	CP	' '
	JR	Z, Cursor_on_RoundSel
	CP	CUR_LEFT
	JR	Z, Cursor_on_RoundSel
	CP	CUR_RIGHT
	JR	Z, Cursor_on_R10
	CP	CUR_UP
	CALL	Z, Inc_R100
	CP	CUR_DOWN
	CALL	Z, Dec_R100
	JR	@b

Cursor_on_R10:					; EhZNg 10̈
	LD	(HL), 0FFh
	LD	HL, VRAMADDR + 26 + 9*40
	LD	(HL), CURSOR_CHR
@@:	CALL	KeyIn
	CP	' '
	JR	Z, Cursor_on_RoundSel
	CP	CUR_LEFT
	JR	Z, Cursor_on_R100
	CP	CUR_RIGHT
	JR	Z, Cursor_on_R1
	CP	CUR_UP
	CALL	Z, Inc_R10
	CP	CUR_DOWN
	CALL	Z, Dec_R10
	JR	@b

Cursor_on_R1:					; EhZNg 1̈
	LD	(HL), 0FFh
	LD	HL, VRAMADDR + 27 + 9*40
	LD	(HL), CURSOR_CHR
@@:	CALL	KeyIn
	CP	' '
	JR	Z, Cursor_on_RoundSel
	CP	CUR_LEFT
	JR	Z, Cursor_on_R10
	CP	CUR_UP
	CALL	Z, Inc_R1
	CP	CUR_DOWN
	CALL	Z, Dec_R1
	JR	@b

Refresh_Round:
	LD	HL, R100	; 365𒴂Ă365ɂ
	LD	A, (HL)
	SUB	'3'+1
	JR	NC, @1f
	INC	A
	JR	NZ, @f
	INC	HL
	LD	A, (HL)
	SUB	'6'+1
	JR	NC, @1f
	INC	A
	JR	NZ, @f
	INC	HL
	LD	A, (HL)
	SUB	'5'+1
	JR	C, @f
@1:	LD	HL, R100
	LD	(HL), '3'
	INC	HL
	LD	(HL), '6'
	INC	HL
	LD	(HL), '5'
Print_Round:
@@:	LD	HL, 25 : 8	; ʐ\
	CALL	Locate
	LD	HL, Mes_000
	CALL	GPrint
	RET

Inc_R100:
	PUSH	AF
	PUSH	HL
Inc_R100_:
	LD	HL, R100
@5:	INC	(HL)
	CALL	Refresh_Round
	POP	HL
	POP	AF
	RET

Inc_R10:
	PUSH	AF
	PUSH	HL
Inc_R10_:
	LD	HL, R10		; 10̌1
	LD	A, (HL)
	CP	'9'
	JR	NZ, @5b
	LD	(HL), '0'	; オ肪A100̌1
	JR	Inc_R100_

Inc_R1:
	PUSH	AF
	PUSH	HL
	LD	HL, R1		; 1̌1
	LD	A, (HL)
	CP	'9'
	JR	NZ, @5b
	LD	(HL), '0'
	JR	Inc_R10_

Dec_R100:
	PUSH	AF
	PUSH	HL
	LD	HL, R100
	LD	A, (HL)
	CP	'0'
	JR	NZ, @f
	INC	HL		; 100̌ "0" Ȃ "001" ɂ
	LD	(HL), '0'
	INC	HL
	LD	(HL), '1'
	DB	0FEh		; (1byte skip)
@@:	DEC	(HL)
	CALL	Refresh_Round
	POP	HL
	POP	AF
	RET

Dec_R10:
	PUSH	AF
	PUSH	HL
	LD	HL, R100	; 2"00"Ȃ
	LD	A, (HL)
	CP	'0'
	JR	NZ, @f
	INC	HL
	LD	A, (HL)
	CP	'0'
	JR	NZ, @f
	INC	HL
	LD	(HL), '1'	; "001"ɂ
@9:	CALL	Refresh_Round
	POP	HL
	POP	AF
	RET
@@:	LD	HL, R10		; 10̌1
Dec_R10_:
	LD	A, (HL)
	CP	'0'
	JR	NZ, @f
	LD	(HL), '9'	; 肪A100̌1
	DEC	HL
@@:	DEC	(HL)
	JR	@9b

Dec_R1:
	PUSH	AF
	PUSH	HL
	LD	HL, R100	; "001"Ȃ牽A
	LD	A, (HL)
	CP	'0'
	JR	NZ, @f
	INC	HL
	LD	A, (HL)
	CP	'0'
	JR	NZ, @f
	INC	HL
	LD	A, (HL)
	CP	'1'+1
	JR	NC, @f
	POP	HL
	POP	AF
	RET
@@:	LD	HL, R1		; 1̌1
	LD	A, (HL)
	CP	'0'
	JR	Z, @f
	DEC	(HL)
	CALL	Refresh_Round
	POP	HL
	POP	AF
	RET
@@:	LD	(HL), '9'	; 肪A10̌1
	DEC	HL
	JR	Dec_R10_

Print_GameMode:
	PUSH	AF
	PUSH	HL
	JR	@1f
Dec_GameMode:
	PUSH	AF
	PUSH	HL
	LD	A, (GameMode)
	DEC	A
	JP	P, @f
	LD	A, 2
	JR	@f
Inc_GameMode:
	PUSH	AF
	PUSH	HL
	LD	A, (GameMode)
	INC	A
	CP	3
	JR	C, @f
	XOR	A
@@:	LD	(GameMode), A
@1:
	LD	HL, 25 : 11
	CALL	Locate
	LD	HL, Mes_Original
	LD	BC, 9
	OR	A
	JR	Z, @f
	ADD	HL, BC
	DEC	A
	JR	Z, @f
	ADD	HL, BC
@@:	CALL	GPrint
	POP	HL
	POP	AF
	RET

;------------------------------------------------------------------------------
;	L[͑҂
;------------------------------------------------------------------------------
KeyIn:
@@:	PUSH	HL
	CALL	7922h
	POP	HL
	OR	A
	JR	NZ, @b
@@:	PUSH	HL
	CALL	7922h
	POP	HL
	OR	A
	JR	Z, @b
	RET

GameMode:	DB	0

Mes_Option:	DB	88h, 0D4h, 0B1h, "OPTION", 0		; (17, 4)
Mes_RoundSel:	DB	48h, 0D5h, 046h, "ROUND@TO@START", 0	; ( 6, 8)
MEs_GameMode:	DB	48h, 0D5h, 0BEh, "GAME@MODE", 0		; ( 6,11)
Mes_Exit:	DB	48h, 0D7h, 00Ah, "EXIT", 0		; (18,19)
;;;Mes_Port:	DB	88h, 0D7h, 072h, "2021", 0
;;;		DB	0C8h,0D7h, 077h, "MZ-1500@PORT@BY", 0
;;;		DB	48h, 0D7h, 086h, "YOUKAN", 0
		DB	0

Mes_Original:	DB	"ORIGINAL", 0
Mes_Arrange:	DB	"ARRANGE@", 0
Mes_Puzzle:	DB	"PUZZLE@@", 0


;----------------------------------------------------------------
; WCXeBbN|[g1gMSXdl̃WCXeBbNǂ
;	OUT: A = srUDRLBA (s:SELECT r:RUN)
;	DES: BC, HL
;----------------------------------------------------------------
ReadJoyPort1:
	LD	HL, 0E008h
	LD	BC,  0E04h		; JA2
	;
	; JA2̗𑨂
	;
@@:	LD	A, C
	AND	(HL)
	JR	Z, @b
@@:	AND	(HL)
	JR	NZ, @b
	;
	; ̎_ŁAJA2̗肩ŒZ7NbNEň26NbNxĂ
	;
	LD	A, (HL)		;  7 ( 7)	*****.A*
	RRCA			;  4 (11)	******.A
	RRCA			;  4 (15)	*******.	Cy = A
	RL	B		;  8 (23)	..wwww.A	wwww = 0111
	LD	A, 06h		;  7 (30)

	AND	(HL)		;  7 ( 7)	.....yB.	y = y1
	ADD	A, B		;  4 (11)	..wwwwBA	if (y1==0) wwww = 0111 else wwww = 1000
	AND	33h		;  7 (18)	..yy..BA	yy = y1 + 1
	RRCA			;  4 (22)	A..yy..B
	RRCA			;  4 (26)	BA..yy..
	LD	B, A		;  4 (30)

	LD	A, (HL)		;  7 ( 7)	*****yR*	y = y0
	AND	06h		;  7 (14)	.....yR.
	ADD	A, B		;  4 (18)	BA..yyR.	yy = y1 + y0 + 1
	RLCA			;  4 (22)	A..yyR.B
	RLCA			;  4 (26)	..yyR.BA
	LD	B, A		;  4 (30)	..UDR.BA

	LD	A, (HL)		;  7 ( 7)	******L*
	RLCA			;  4 (11)	*****L**
	AND	C		;  4 (15)	.....L..
	OR	B		;  4 (19)	..UDRLBA

	OR	0C0h		;		11UDRLBA
	LD	C, A
	AND	0Ch		;		0000RL00
	LD	A, C
	RET	NZ

	;
	; RL == 00 Ȃ UD fR[h RUN, SELECT ̏Ԃɕϊ
	;
				;   UD=11     UD=10     UD=01
	AND	30h		; 00110000  00100000  00010000
	DEC	A		; 00101111  00011111  00001111
	ADD	A, A		; 01011110  00111110  00011110
	ADD	A, A		; 10111100  01111100  00111100
	OR	B		; 101111BA  011111BA  001111BA

	RET

;------------------------------------------------------------------------------
; WCXeBbNڑĂ邩ǂ`FbN
; JA2/JB2LowɂȂ邩ǂ
;	OUT: Cy = 0  ڑĂ
;		= 1  ڑĂȂ
;	DES: AF, BC, HL
;------------------------------------------------------------------------------
CheckJoy1:
	LD	A, 04h		; JA2
	LD	B, 7
	LD	HL, 0E008h
@@:	AND	(HL)
	DJNZ	@b
	RET	Z
	SCF
	RET


	DS	8000h - $

;==============================================================================
;	CoCi
;==============================================================================
	BINCLUDE "A.BIN"

	END	Entry
