﻿//	
//	  ┌┐┌┐┌┐┌┐┌┐┌┐┌┐┌┐
//	┌┴┴┴┴┴┴┴┴┴┴┴┴┴┴┴┴┐
//	│    ＞＞　ＦＡＮＴＩＣ　＜＜    │
//	└┐                              │
//	┌┘Ｂｙ　Ｇａｍｅ　Ｒｏｍａｎ    │  Copyright
//	│            ＆　ＴＡＭＯ        │  (C) 1984
//	└┬┬┬┬┬┬┬┬┬┬┬┬┬┬┬┬┘
//	  └┘└┘└┘└┘└┘└┘└┘└┘    Y.M.C SOFT
//

unsigned short SC;		// スコア
unsigned short HS;		// ハイスコア
	 short NO;		// ティッ君 残機
unsigned short PA;		// ROUND
unsigned short EX;		// エクステンドチェック

unsigned char GA[40][25];	// 仮想画面

unsigned short PO;		// パワーアップ終了タイム
unsigned short NE;		// タイムゲージ
unsigned char NE1;

unsigned char G1;
unsigned char G2;

unsigned char J1;
unsigned char J3;
unsigned char SI;

char X, Y;		// ティッ君座標
char X0, Y0;
char X1, Y1;
char X2, Y2;
unsigned char MO;

char BX[5];		// ブロック座標
char BY[5];
char BX1[5];
char BY1[5];
char BI[5];
char BB[5];

char TX[4];		// グローブン座標
char TY[4];
char TX1[4];
char TY1[4];
char TM[4];
char TX0[4];
char TY0[4];

char CX, CY, CT;	// コイン

char SX, SY, SS, ST;	// 得点表示

char MX, MY, MT;	// オイル

unsigned char GM;	// ゲームモード

//=====================================================================================================
// プロトタイプ宣言
//=====================================================================================================
void mainloop(void);
void gameloop(void);
void process_ticun(void);
void draw_ticun(void);
void kick_block(void);
void draw_block(unsigned char);
void process_block(void);
void ticun_MO(unsigned char);
void gloven_MO(unsigned char, unsigned char);
void gloven_die(unsigned char);
void draw_gloven_smashed(unsigned char, unsigned char);
void draw_ticun_smashed(unsigned char);
void process_score(void);
void new_score(char, char, unsigned char);
void process_gloven(void);
void draw_gloven(unsigned char);
void draw_gloven_shrunk(unsigned char);
void add_score(unsigned short);
void stage_clear(void);
void process_oil(void);
void process_coin(void);
void select_coin(void);
void miss(void);
void gameover(void);
unsigned char title(void);
void prepare_level(void);

//=====================================================================================================
// ランタイムルーチン
//=====================================================================================================
void GPut(unsigned char x, unsigned char y, unsigned char a) __naked {
#asm
	ld	ix, 2
	add	ix, sp
	ld	a, (ix)
	ld	l, (ix+2)
	ld	h, (ix+4)
	jp	0x790A
#endasm
}
void Locate(unsigned char x, unsigned char y) __naked {
#asm
	ld	ix, 2
	add	ix, sp
	ld	l, (ix)
	ld	h, (ix+2)
	jp	0x790D
#endasm
}
void Color(unsigned char c) __z88dk_fastcall __naked {
#asm
	ld	a, l
	jp	0x7910
#endasm
}
void GPrint(unsigned char *p) __z88dk_fastcall __naked {
#asm
	jp	0x7913
#endasm
}
void Gauge(unsigned short x, unsigned char c) __naked {
#asm
	ld	ix, 2
	add	ix, sp
	ld	c, (ix)
	ld	l, (ix+2)
	ld	h, (ix+3)
	jp	0x7916
#endasm
}
void GPrintNum(unsigned short num, unsigned char keta) __naked {
#asm
	ld	ix, 2
	add	ix, sp
	ld	c, (ix)
	ld	l, (ix+2)
	ld	h, (ix+3)
	jp	0x7919
#endasm
}
void Sound(unsigned short n, unsigned short len) __naked {
#asm
	ld	ix, 2
	add	ix, sp
	ld	c, (ix)
	ld	b, (ix+1)
	ld	l, (ix+2)
	ld	h, (ix+3)
	jp	0x791C
#endasm
}
void Wait(unsigned short n) __z88dk_fastcall __naked {
#asm
	jp	0x791F
#endasm
}
void Option(unsigned short *round, unsigned char *gamemode) __naked {
#asm
	ld	ix, 2
	add	ix, sp
	ld	e, (ix)
	ld	d, (ix+1)
	ld	l, (ix+2)
	ld	h, (ix+3)
	jp	0x7925
#endasm
}

unsigned char Inkey(void) {
#asm
	call	0x7922
	ld	l, a
	ld	h, 0
#endasm
}

unsigned char Inkey1(void) {
	unsigned char k;
	while (Inkey() != 0);
	while ((k = Inkey()) == 0);
	return k;
}

unsigned short KurosawaRandom(void) {
	static unsigned short lastRnd;
	unsigned short d0;
	d0 = lastRnd;
	d0 ^= 0x9630;
	d0 -= 0x6553;
	d0 = (d0 << 2) | (d0 >> 14);
	lastRnd = d0;
}
unsigned short Rnd(r) {
	return KurosawaRandom() % r;
}

//=====================================================================================================
//  FANTIC メイン
//=====================================================================================================
void main(void) {
	unsigned char i;

	HS = 500;			// ハイスコア = 5,000
	PA = 1;				// ROUND = 1

	while (1) {

	    SC = 0;			// スコア     =     0
	    NO = 0;			// ティッ君 残機 = 0

	    GM = 0;			// ゲームモード = ORIGINAL

	    //
	    // ゲームエリアの周囲の仮想画面を壁で埋める
	    //
	    for (i=0; i<40; i++) {
		GA[i][ 1] = GA[i][ 2] = 1;	    // 壁
		GA[i][23] = GA[i][24] = 1;	    // 壁
	    }
	    for (i=0; i<25; i++) {
		GA[ 0][i] = GA[ 1][i] = 1;	    // 壁
		GA[38][i] = GA[39][i] = 1;	    // 壁
	    }

	    Color(7);
	    Locate( 8, 1); GPrintNum(SC, 5);		// スコア表示
	    Locate(18, 1); GPrintNum(HS, 5);		// ハイスコア表示
	    Locate(30, 1); GPrintNum(PA, 3);		// ROUND表示
	    Locate(35, 1); GPrintNum(NO, 2);		// 残機表示

	    Gauge(0xFFFF, 2);				// ゲージを赤で初期化

	    while (title() != 0);			// タイトル・オプション

	    NO = 4;					// 残機 = 4
	    EX = 0;					// 

	    Color(7);
	    Locate( 8, 1); GPrintNum(SC, 5);		// スコア表示

	    mainloop();
	    gameover();
	}
}

//129 ' START 2 ' =====================================================================================================
void mainloop(void) {
	unsigned char i;

	while (1) {
	    Locate(30, 1); GPrintNum(PA, 3);				// ROUND表示
	    prepare_level();						// ステージデータを展開する

	    X = 20; Y = 13;
	    X0 = 0; Y0 = 0;
	    X1 = 0; Y1 = 1;
	    for (i=0; i<5; i++) {
		BY[i] = -1;
		BB[i] = 0;
	    }
	    MO = 0;
	    G1 = 0;							// ティッ君 歩行パターン (0,1)
	    G2 = 0;
	    NE = 303;
	    NE1 = 0;

	    Locate(35, 1); GPrintNum(NO, 2);				// 残機表示
	    Gauge(0xFFFF, 2);						// ゲージを赤で埋める

	    TX[0] =  2; TY[0] =  3;					// グローブン 座標初期化
	    TX[1] =  2; TY[1] = 21;
	    TX[2] = 36; TY[2] =  3;
	    TX[3] = 36; TY[3] = 21;

	    for (i=0; i<4; i++) {
		TM[i] = -45;
		TX0[i] = 0;
		TY0[i] = 0;
		TY1[i] = 0;
		TX1[i] = (i < 2) ? 1 : -1;
	    }

	    SX = 0; SY = 0;
	    ST = 0; SS = 0;
	    MT = 0; MY = 0;
	    PO = 0;
	    SI = 0;

	    select_coin();						// コインの種類を決める

	    do {
		CX = 2 + Rnd(18) * 2;					// コイン座標を初期化
		CY = 3 + Rnd(10) * 2;
	    } while (GA[CX][CY] < 2);					// ブロックの下でなければやり直す

	    //
	    // ステージ開始
	    //
	    Color(7);
	    gameloop();
	    if (NO < 0) return;
	}
}

//-----------------------------------------------------------------------------------------------------------------------------
//	ゲーム処理
//-----------------------------------------------------------------------------------------------------------------------------
//150
void gameloop(void) {
	unsigned char i, j;

	while (1) {

	    process_score();							// 得点表示
	    if (GM != 2) process_oil();						// オイルの処理 (PUZZLEモード時はなし)

	    if (MO == 0) {
		process_ticun();						// ティッ君の処理
		draw_ticun();
	    }

	    if (GA[18][11] == 3 && GA[20][11] == 3 &&				// 面クリア条件のチェック
		GA[18][13] == 3 && GA[20][13] == 3) {
		j= 0;
		for (i=0; i<5; i++) {
		    if (BX[i] >= 18 && BX[i] <= 21 &&
			BY[i] >= 11 && BY[i] <= 14) {
			j = 1;
		    }
		}
		if (j == 0) {
		    stage_clear();
		    return;							// 面クリアして抜ける
		}
	    }

	    process_block();							// ブロックの処理

	    if (GM != 2) process_gloven();					// グローブンの処理 (PUZZLEモード時はなし)

	    for (i=0; i<4; i++) {						// ティッ君とグローブンのヒットチェック
		if (TM[i] < 0) {
		    continue;
		}
		if (TX[i]-X > -2 && TX[i]-X < 2 &&
		    TY[i]-Y > -2 && TY[i]-Y < 2 &&
		    (X == TX[i] || Y == TY[i]) && TM[i] == 0) {
		    if (MO == 0) {
			if (PO == 0) {
			    SI = 1;
			} else if (GM == 1) {					// アレンジモード時は
			    new_score(TX[i], TY[i], 1);				// パワーアップ中に触れたグローブンを倒せる
			    gloven_die(i);
			}
		    }
		}
	    }
	    if (MO != 0 && MO != 1) {
		SI = 1;
	    }
	    if (SI == 1 && MO == 0) {						// 1ミス
		miss();
		return;
	    }

	    if (GM != 2) NE1++;							// タイムゲージ減少処理 (PUZZLEモード時はなし)
	    if (NE1 == 4) {
		NE1 = 0;
		Gauge(NE, 1);
		NE--;
		if (NE < 16) {							// ゲージがなくなったら1ミス
		    miss();
		    return;
		}
	    }
	    if (PO == NE) {							// パワーアップ終了チェック
		PO = 0;
	    }

	    process_coin();							// コインの処理

	    Wait(100);
	}
}

//-----------------------------------------------------------------------------------------------------------------------------
//	ティッ君の処理
//-----------------------------------------------------------------------------------------------------------------------------
//200
void process_ticun(void) {
	unsigned char j, k;
	unsigned char c, p;
	char i1, i2;

	k = Inkey();
	if (k == ' ') {
	    i1 = X + X1;
	    i2 = Y + Y1;
	    if (i1 > 1 && i1 < 37 && i2 > 2 && i2 < 22 &&
		X0 == 0 && Y0 == 0 && BY[0] == -1 && GA[X+X1*2][Y+Y1*2] > 1) {
		BX[0] = X + X1*2;								// 飛ばすブロックの座標
		BY[0] = Y + Y1*2;
		BI[0] = GA[BX[0]][BY[0]];							// 飛ばすブロックの種類
		BX1[0] = X1;									// 飛ばすブロックのXY増分
		BY1[0] = Y1;
		kick_block();
		return;
	    }
	}

	X2 = 0;
	Y2 = 0;

	switch (k) {
	    case 0x12: Y2 = -1; break;					// 上
	    case 0x11: Y2 =  1; break;					// 下
	    case 0x14: X2 = -1; break;	    				// 左
	    case 0x13: X2 =  1; break;					// 右
	    case 0x64: SI = 1; return;					// SHIFT+BREAK
	    default:
		return;
	}

	for (p=0; p<2; p++) {
	    //
	    // 210
	    //
	    if (X+X2 >= 2 && X+X2 <= 36 && Y+Y2 >= 3 && Y+Y2 <= 21) {			// 移動するとはみ出る？
		j = 0;
		for (i1=0; i1<2; i1++) {
		    for (i2=0; i2<2; i2++) {
			c = GA[X+X2+i1][Y+Y2+i2];
			if (c > 1 && X0 == 0 && Y0 == 0) {				// 移動方向にブロックが有り、かつ座標が奇数位置でない
			    X1 = X2;
			    Y1 = Y2;
			    j = 1;
			}
			if (c > 0) {							// (BUG??? j==1になることはない？)
			    j = 2;
			}
		    }
		}
		if (j == 1) {
		    return;
		}
		if (j == 0) {
		    //
		    // 230
		    //
		    GPut(X, Y, 0xFF);
		    X += X2;								// ティッ君の座標を更新
		    Y += Y2;
		    X1 = X2;								// X1,Y1 = 最後に移動した方向
		    Y1 = Y2;
		    G1 ^= 1;								// G1を反転
		    if (G1 == 0) {							// 歩行音
			Sound(58, 5);
			Sound(50, 20);
		    } else {
			Sound(58, 5);
			Sound(70, 5);
		    }
		    if (X2 != 0) {
			X0 ^= 1;							// 左右移動したら、X0を反転
		    }
		    if (Y2 != 0) {
			Y0 ^= 1;							// 上下移動したら、Y0を反転
		    }
		    return;
		}
	    }
	    //
	    // 240
	    //
	    X2 = X1;
	    Y2 = Y1;
	}
}

//-----------------------------------------------------------------------------------------------------------------------------
//	ティッ君のパターンを描画
//-----------------------------------------------------------------------------------------------------------------------------
//251
void draw_ticun(void) {
	unsigned char c;

	if (X1 != 0) {
	    //
	    // 左右向き
	    //
	    if (X1 < 0) {
		c = 0xA7;							// ティッ君 左向き1
	    } else {
		c = 0xAF;							// ティッ君 右向き1
	    }
	    GPut(X, Y, c + (G1 << 2));
	} else {
	    //
	    // 上下向き
	    //
	    Locate(X, Y);
	    if (Y1 < 0) {
		GPrint("\xBD\xBE");						// ティッ君 上向き
		Locate(X, Y+1);
		if (G1 == 0) {
		    GPrint("\xBF\xC0");
		} else {
		    GPrint("\xC1\xC2");
		}
	    } else {
		GPrint("\xB7\xB8");						// ティッ君 下向き
		Locate(X, Y+1);
		if (G1 == 0) {
		    GPrint("\xB9\xBA");
		} else {
		    GPrint("\xBB\xBC");
		}
	    }
	}
	//
	// パワーアップ中の炎
	//
	if (PO > 0) {
	    Locate(X, Y);
	    if (G2 == 1) {
		GPrint("\x1C\x1D");
	    } else {
		GPrint("\x1E\x1F");
	    }
	}
}

//-----------------------------------------------------------------------------------------------------------------------------
//	ブロックを飛ばす
//-----------------------------------------------------------------------------------------------------------------------------
//300
void kick_block(void) {
	unsigned char j;
	char i1, i2;

	J1 = 0;
	if (X+X1*4 < 2 || X+X1*4 > 36 || Y+Y1*4 < 3 || Y+Y1*4 > 21 || 				// ブロックのさらに先が画面外 または
	    GA[BX[0]+BX1[0]*2][BY[0]+BY1[0]*2] > 0) {						// ブロックのさらに先が障害物なら
	    BX1[0] = -BX1[0];									// ブロックの座標増分を反転
	    BY1[0] = -BY1[0];
	    //
	    // 320
	    //
	    i1 = X + BX1[0]*2;									// ティッ君の背後の座標
	    i2 = Y + BY1[0]*2;
	    draw_ticun();									// ティッ君のパターンを描画
	    if (i1 < 2 || i1 > 36 || i2 < 3 || i2 > 21) {					// はみ出る？
		BY[0] = -1;
		return;
	    }
	} else {
	    //
	    // 315
	    //
	    J1 = 1;										// ブロックの先は空白だった
	}
	//
	// 322
	//
	for (j=1; j<5; j++) {
	    if (BY[j] != -1 &&
		BX[0]-BX[j] > -4 && BX[0]-BX[j] < 4 &&
		BY[0]-BY[j] > -4 && BY[0]-BY[j] < 4) {
		BY[0] = -1;
	    }
	}
	if (BY[0] == -1) {
	    return;
	}
	if (J1 == 0) {
	    MO = 1;
	}
	draw_block(0);										// 移動中のブロックのパターン描画
	return;
}

//-----------------------------------------------------------------------------------------------------------------------------
//	移動中のブロックのパターン描画
//-----------------------------------------------------------------------------------------------------------------------------
//350
void draw_block(unsigned char i) {
	unsigned short a;
	unsigned char c;

	for (a=16; a<=13; a--) {
	    Sound(a, 75);
	}

	GA[BX[i]  ][BY[i]  ] = 0;
	GA[BX[i]+1][BY[i]  ] = 0;
	GA[BX[i]  ][BY[i]+1] = 0;
	GA[BX[i]+1][BY[i]+1] = 0;

	if (BX1[i] != 0) {			// 方向別にブロックのパターン番号を求める
	    //
	    // 左右向き
	    //
	    if (BX1[i] < 0) {
		c = 0x6F;			// 水色ブロック 左寄り
	    } else {
		c = 0x73;			// 水色ブロック 右寄り
	    }
	} else {
	    //
	    // 上下向き
	    //
	    if (BY1[i] < 0) {
		c = 0x67;			// 水色ブロック 上寄り
	    } else {
		c = 0x6B;			// 水色ブロック 下寄り
	    }
	}

	if (BI[i] == 3) {			// 金色ブロック
	    c += 0x10;
	}

	GPut(BX[i], BY[i], c);
}

//-----------------------------------------------------------------------------------------------------------------------------
//	ブロックの処理
//-----------------------------------------------------------------------------------------------------------------------------
//500
void process_block(void) {
	unsigned char i, j;
	char i1, i2;
	unsigned short s;

	for (i=0; i<5; i++) {

	    if (BY[i] < 0) continue;

	    i1 = BX[i] + BX1[i] * 2;
	    i2 = BY[i] + BY1[i] * 2;
	    if (i1 >= 2 && i1 <= 36 && i2 >= 3 && i2 <= 21) {						// はみ出る？
		//
		// 514
		//
		J1 = 0;
		J3 = 0;
		if (X-i1 > -2 && X-i1 < 2 && Y-i2 > -2 && Y-i2 < 2) {					// ティッ君に当たった？
		    ticun_MO(i);
		}
		for (j=0; j<4; j++) {
		    if (TX[j]-i1 > -2 && TX[j]-i1 < 2 && TY[j]-i2 > -2 && TY[j]-i2 < 2) {		// グローブンに当たった？
			gloven_MO(i, j);
		    }
		}
		if (J1 != 1 && GA[i1][i2] == 0) {
		    //
		    // 550  まだ進む
		    //
		    GPut(BX[i], BY[i], 0xFF);								// ブロック消去
		    GA[BX[i]  ][BY[i]  ] = 0;								// 仮想画面のブロックを消去
		    GA[BX[i]+1][BY[i]  ] = 0;
		    GA[BX[i]  ][BY[i]+1] = 0;
		    GA[BX[i]+1][BY[i]+1] = 0;
		    BX[i] += BX1[i] * 2;
		    BY[i] += BY1[i] * 2;
		    GA[BX[i]  ][BY[i]  ] = BI[i];							// 仮想画面にブロックを再設定
		    GA[BX[i]+1][BY[i]  ] = BI[i];
		    GA[BX[i]  ][BY[i]+1] = BI[i];
		    GA[BX[i]+1][BY[i]+1] = BI[i];
		    GPut(BX[i], BY[i], (BI[i] == 3) ? 0x63 : 0x5F);						// ブロック描画
		    if (MO == i+1) {
			draw_ticun_smashed(i);
		    }
		    for (j=0; j<4; j++) {
			if (TM[j] == i+1) {
			    draw_gloven_smashed(i, j);
			}
		    }
		    continue;
		}
	    }
	    //
	    // 530  ブロックが止まった
	    //
	    GPut(BX[i], BY[i], (BI[i] == 3) ? 0x63 : 0x5F);						// ブロック描画
	    GA[BX[i]  ][BY[i]  ] = BI[i];								// 仮想画面にブロックを再設定
	    GA[BX[i]+1][BY[i]  ] = BI[i];
	    GA[BX[i]  ][BY[i]+1] = BI[i];
	    GA[BX[i]+1][BY[i]+1] = BI[i];
	    if (J3 == 0) {
		BY[i] = -1;
		continue;
	    }
	    new_score(BX[i]+BX1[i]*2, BY[i]+BY1[i]*2, J3);
	    BY[i] = -1;
	}
}

//-----------------------------------------------------------------------------------------------------------------------------
//	ティッ君 ブロックに押されて移動
//-----------------------------------------------------------------------------------------------------------------------------
//600
void ticun_MO(unsigned char i) {
	GPut(X, Y, 0xFF);									// ティッ君消去
	MO = i + 1;
	X0 = 0;
	Y0 = 0;
	X = BX[i] + BX1[i] * 4;									// ティッ君の座標をブロックの先に設定
	Y = BY[i] + BY1[i] * 4;
	if (X < 2 || X > 36 || Y < 3 || Y > 21 ||						// はみ出る？
	    GA[X][Y] != 0) {									// ティッ君の座標に障害物がある？
	    X = BX[i] + BX1[i] * 2;
	    Y = BY[i] + BY1[i] * 2;
	    MO = 0;
	    J1 = 1;
	}
}

//-----------------------------------------------------------------------------------------------------------------------------
//	グローブン ブロックに押されて移動 (J = グローブン番号(0-3))
//-----------------------------------------------------------------------------------------------------------------------------
//650
void gloven_MO(unsigned char i, unsigned char j) {

	if (CY >= 0) {
	    if (TM[j] < 0) {
		J1 = 1;
		return;
	    }
	}

	GPut(TX[j], TY[j], 0xFF);							// グローブン消去

	TM[j] = i + 1;
	TX0[j] = 0;
	TY0[j] = 0;
	TX[j] = BX[i] + BX1[i] * 4;							// グローブンの座標をブロックの先に設定
	TY[j] = BY[i] + BY1[i] * 4;
	if (TX[j] < 2 || TX[j] > 36 || TY[j] < 3 || TY[j] > 21 ||			// はみ出る？
	    GA[TX[j]][TY[j]] > 0) {							// 障害物がある？
	    TX[j] = BX[i] + BX1[i] * 2;
	    TY[j] = BY[i] + BY1[i] * 2;
	    TM[j] = 0;
	    J1 = 1;
	    if (i == 0) {								// ティッ君が押したブロック？
		J3++;
		gloven_die(j);
	    }
	}
}

void gloven_die(unsigned char j) {
	TM[j] = -60;
	switch (j) {								// グローブンの座標を初期位置に戻す
	    case 0: TX[0] =  2; TY[0] =  3; break;
	    case 1: TX[1] =  2; TY[1] = 21; break;
	    case 2: TX[2] = 36; TY[2] =  3; break;
	    case 3: TX[3] = 36; TY[3] = 21; break;
	}
}

//-----------------------------------------------------------------------------------------------------------------------------
//	グローブンのつぶれパターンを描画
//-----------------------------------------------------------------------------------------------------------------------------
//700
void draw_gloven_smashed(unsigned char i, unsigned char j) {
	unsigned char c;

	if (i > 0) {
	    draw_gloven(j);								// グローブンのパターンを描画
	    return;
	}

	if (BX1[i] != 0) {
	    if (BX1[i] < 0) {
		c = 0xEA;								// グローブン 右向き つぶれ
	    } else {
		c = 0xE6;								// グローブン 左向き つぶれ
	    }
	} else {
	    if (BY1[i] < 0) {
		c = 0xE2;								// グローブン 下向き つぶれ
	    } else {
		c = 0xDE;								// グローブン 上向き つぶれ
	    }
	}

	GPut(TX[j], TY[j], c);
}

//-----------------------------------------------------------------------------------------------------------------------------
//	ティッ君のつぶれパターンを描画 (I = ブロック番号)
//-----------------------------------------------------------------------------------------------------------------------------
//730
void draw_ticun_smashed(unsigned char i) {
	unsigned char c;

	if (i == 0) {
	    draw_ticun();
	    return;
	}

	if (BX1[i] != 0) {
	    if (BX1[i] < 0) {
		c = 0xDA;								// ティッ君 右向き つぶれ
	    } else {
		c = 0xD6;								// ティッ君 左向き つぶれ
	    }
	} else {
	    if (BY1[i] < 0) {
		c = 0xD2;								// ティッ君 下向き つぶれ
	    } else {
		c = 0xCE;								// ティッ君 上向き つぶれ
	    }
	}

	GPut(X, Y, c);
}

//-----------------------------------------------------------------------------------------------------------------------------
//	得点表示
//-----------------------------------------------------------------------------------------------------------------------------
//750
void process_score(void) {

	if (ST == 0) return;								// 得点表示中でなければ何もしない

	if (GA[SX][SY] > 1) return;							// 表示座標が空白でなくなったら表示をやめる

	ST--;										// 表示タイマーカウントダウン
	if (ST == 0) {									// expireしたら消去する
	    switch (GA[SX][SY]) {
		case 2: GPut(SX, SY, 0x5F); return;					// 水色ブロック
		case 3: GPut(SX, SY, 0x63); return;					// 金色ブロック
		default:
		case 0: GPut(SX, SY, 0xFF); return;
	    }
	    return;
	}

	if (ST == 19) {
	    switch (SS) {								// スコア加算
		case 1: add_score( 5); break;
		case 2: add_score(10); break;
		case 3: add_score(20); break;
		case 4: add_score(50); break;
		default:               break;
	    }
	}

	Locate(SX, SY);
	switch (SS) {
	    case 1: GPrint("\xC3\xC4"); break;						// "50"
	    case 2: GPrint("\xC7\xC8"); break;						// "100"
	    case 3: GPrint("\xC9\xCA"); break;						// "200"
	    case 4: GPrint("\xCB\xCC"); break;						// "500"
	    default:               break;
	}
	Locate(SX, SY+1); GPrint("\xC5\xC6");						// "Pt"
}

void new_score(char x, char y, unsigned char j) {
	unsigned short s;

	if (ST > 0) {
	    GPut(SX, SY, 0xFF);
	}
	SX = x;
	SY = y;
	if (SX < 2) {
	    SX = 2;
	}
	if (SX > 36) {
	    SX = 36;
	}
	if (SY < 3) {
	    SY = 3;
	}
	if (SY > 21) {
	    SY = 21;
	}
	for (s=15; s<=50; s++) {
	    Sound(s, 6);
	}
	ST = 20;
	SS = j;
}

//-----------------------------------------------------------------------------------------------------------------------------
//	グローブンの処理
//-----------------------------------------------------------------------------------------------------------------------------
//800
void process_gloven(void) {
	unsigned char i, j;
	unsigned char j1, j2;
	char i1, i2;
	char tmp;

	G2 ^= 1;

	for (i=0; i<4; i++) {

	    if (TM[i] != 10) {

		if (TM[i] > 0) continue;

		if (TM[i] < 0) {
		    //
		    // 復活待ち時の処理
		    //
		    Wait(9);
		    if (GA[TX[i]][TY[i]] == 3) continue;
		    TM[i]++;
		    if (TM[i] < 0) {
			draw_gloven_shrunk(i);						// グローブンの縮みパターンを描画
			continue;
		    }
		    GA[TX[i]  ][TY[i]  ] = 0;
		    GA[TX[i]+1][TY[i]  ] = 0;
		    GA[TX[i]  ][TY[i]+1] = 0;
		    GA[TX[i]+1][TY[i]+1] = 0;
		}
		else if (GM == 1 && G2 == 1) {						// アレンジモード時は
		    draw_gloven(i);							// グローブンの速度 1/2
		    continue;
		}

	    }

	    GPut(TX[i], TY[i], 0xFF);							// グローブンを消去

	    if (TM[i] == 10) {
		TX[i] += TX1[i];							// 座標更新
		TY[i] += TY1[i];
	    }

	    //
	    //822
	    //
	    i1 = TX[i] + TX1[i];
	    i2 = TY[i] + TY1[i];
	    if (TX0[i] != 0 || TY0[i] != 0 ||
		(Rnd(GM == 0 ? 6 : 18)+TM[i] != 0 &&					// アレンジモード時はブロックを飛ばす頻度を減らす
		i1 >= 2 && i1 <= 36 && i2 >= 3 && i2 <= 21)) {

		//
		//824
		//
		j = 0;
		for (j1=0; j1<2; j1++) {
		    for (j2=0; j2<2; j2++) {
			if (GA[i1+j1][i2+j2] > 0) {
			    j = GA[i1+j1][i2+j2];
			}
		    }
		}
		//
		//827
		//
		if (j > 0) {
		    //
		    //830
		    //
		    if (TM[i] != 10) {
			TM[i] = 0;
			i1 = TX[i] + TX1[i];
			i2 = TY[i] + TY1[i];
			if (j == 2 && i1 > 1 && i1 < 37 && i2 > 2 && i2 < 22 &&
			    Rnd(2) > 0 && TX0[i] == 0 && TY0[i] == 0 && BY[i+1] == -1) {
			    BX[i+1] = TX[i] + TX1[i] * 2;
			    BY[i+1] = TY[i] + TY1[i] * 2;
			    BI[i+1] = j;
			    BX1[i+1] = TX1[i];
			    BY1[i+1] = TY1[i];

			    //
			    // 840
			    //
			    J1 = 0;
			    if (TX[i]+TX1[i]*4 < 2 || TX[i]+TX1[i]*4 > 36 ||
				TY[i]+TY1[i]*4 < 3 || TY[i]+TY1[i]*4 > 21 ||
				GA[BX[i+1]+BX1[i+1]*2][BY[i+1]+BY1[i+1]*2] > 0) {
				BX1[i+1] = -BX1[i+1];
				BY1[i+1] = -BY1[i+1];
				//
				//843
				//
				i1 = TX[i] + BX1[i+1] * 2;
				i2 = TY[i] + BY1[i+1] * 2;
				draw_gloven(i);					// グローブンのパターンを描画
				if (i1 < 2 || i1 > 36 || i2 < 3 || i2 > 21) {
				    BY[i+1] = -1;
				    goto gl832;
				}
			    } else {
				J1 = 1;
			    }
			    //
			    // 844
			    //
			    for (j=0; j<5; j++) {
				if (BY[j] == -1 || j == i+1) continue;
				if (BX[i+1]-BX[j] > -4 && BX[i+1]-BX[j] < 4 &&
				    BY[i+1]-BY[j] > -4 && BY[i+1]-BY[j] < 4) {
				    BY[i+1] = -1;
				}
			    }
			    if (BY[i+1] == -1) {
				goto gl832;
			    }
			    if (GA[TX[i]+BX1[i+1]*2][TY[i]+BY1[i+1]*2] > 0 && J1 == 0) {
				BY[i+1] = -1;
				goto gl832;
			    }
			    if (J1 == 0) {
				TM[i] = 1;
			    }
			    draw_block(i+1);
			    draw_gloven(i);
			    continue;
			}
		    }
		} else {
		    //
		    // 850
		    //
		    TX[i] = i1;
		    TY[i] = i2;
		    if (TX1[i] != 0) {
			TX0[i] = 1 - TX0[i];
		    }
		    if (TY1[i] != 0) {
			TY0[i] = 1 - TY0[i];
		    }
		    if (TM[i] == 10) {
			TX0[i] = 0;
			TY0[i] = 0;
		    }
		    draw_gloven(i);
		    continue;
		}

	    }
gl832:
	    //
	    //832
	    //
	    if (TM[i] == 10) {					// 座標の更新をキャンセル
		TX[i] -= TX1[i];
		TY[i] -= TY1[i];
	    }

	    TM[i] = 0;						// ランダムに90度向きを変える
	    tmp = TX1[i];
	    TX1[i] = TY1[i];
	    TY1[i] = tmp;
	    if (Rnd(2) == 0) {
		TX1[i] = -TX1[i];
		TY1[i] = -TY1[i];
	    }

	    if (GA[TX[i]+TX1[i]*2][TY[1]+TY1[i]*2] > 0) {
		TX1[i] = -TX1[i];
		TY1[i] = -TY1[i];
	    }
	    draw_gloven(i);
	}
}

//-----------------------------------------------------------------------------------------------------------------------------
//	グローブンのパターンを描画 (I = 番号(0-3))
//-----------------------------------------------------------------------------------------------------------------------------
//871
void draw_gloven(unsigned char i) {
	unsigned char c;
	if (TX1[i] != 0) {
	    //
	    // 左右向き
	    //
	    if (TX1[i] < 0) {
		c = 0x87;								// グローブン 左向き1
	    } else {
		c = 0x8F;								// グローブン 右向き1
	    }
	} else {
	    //
	    // 上下向き
	    //
	    if (TY1[i] < 0) {
		c = 0x97;								// グローブン 上向き1
	    } else {
		c = 0x9F;								// グローブン 上向き1
	    }
	}
	GPut(TX[i], TY[i], c + (G2 << 2));
}

//-----------------------------------------------------------------------------------------------------------------------------
//	グローブンの縮みパターンを描画 (I = 番号(0-3))
//-----------------------------------------------------------------------------------------------------------------------------
void draw_gloven_shrunk(unsigned char i) {
	if (TM[i] > -9) {
	    GPut(TX[i], TY[i], 0x87);							// グローブン 左向き1
	    return;
	}
	if (TM[i] > -19) {
	    GPut(TX[i], TY[i], 12);							// グローブン 縮み3
	    return;
	}
	if (TM[i] > -29) {
	    GPut(TX[i], TY[i], 8);							// グローブン 縮み2
	    return;
	}
	if (TM[i] > -46) {
	    GPut(TX[i], TY[i], 4);							// グローブン 縮み1
	    return;
	}
}

//-----------------------------------------------------------------------------------------------------------------------------
//	スコア加算	(S1 = 加算値)
//-----------------------------------------------------------------------------------------------------------------------------
//900
void add_score(unsigned short s1) {
	unsigned char i;

	SC += s1;
	if (SC > 60000) SC = 60000;
	Locate(8, 1); GPrintNum(SC, 5);				// スコア表示
	if (SC > HS) {
	    HS = SC;
	    Locate(18, 1); GPrintNum(HS, 5);			// ハイスコア表示
	}
	EX += s1;
	if (EX >= 500) {
	    EX -= 500;
	    NO++;
	    Locate(35, 1); GPrintNum(NO, 2);			// 残機表示
	    for (i=0; i<4; i++) {
		Sound(30, 80);
		Sound(20, 80);
	    }
	}
}

//-----------------------------------------------------------------------------------------------------------------------------
//	面クリア
//-----------------------------------------------------------------------------------------------------------------------------
//1000
void stage_clear(void) {
	unsigned short i;
	unsigned short j;
	Wait(1000);
	j = 0;
	for (i = NE; i >= 16; i--) {
	    Gauge(i, 1);
	    j++;
	    j &= 7;
	    if (j == 0) {
		j = 0;
		if (PO != 0 && i > PO) {
		    add_score(2);				// 黄色ゲージ部分はスコア2倍
		} else {
		    add_score(1);				// ゲージの残りをスコアに加算
		}
		Sound(70, 30);
	    }
	}
	Wait(1000);
	PA++;							// ROUND++
	if (PA > 366) {
	    PA = 1;
	}
}

//-----------------------------------------------------------------------------------------------------------------------------
//	オイルの処理
//-----------------------------------------------------------------------------------------------------------------------------
//2000
void process_oil(void) {
	unsigned short i, j;
	unsigned short i1;

	if (MY == 0) {
	    MX = 2 + Rnd(18) * 2;					// オイルの座標を決める
	    MY = 3 + Rnd(10) * 2;
	    if ((Rnd(100) > 0) || (GA[MX][MY] > 0)) {
		MY = 0;							// 空白でなければリセット
		return;
	    }
	}

	if (GA[MX][MY] > 1) {
	    MY = 0;							// 空白でなくなっていたらリセット
	    MT = 0;
	    return;
	}

	MT++;
	if (MT >= 40) {							// タイムアウトしたら消滅する
	    GPut(MX, MY, 0xFF);
	    MT = 0;
	    MY = 0;
	    return;
	}

	if (X == MX && Y == MY) {					// ティッ君とオイルのヒットチェック
	    j = NE - 65;						// オイル取得
	    if (j < 16) j = 16;
	    for (i=20; i>=15; i--) {
		Sound(i, 200);
	    }
	    PO = j - 1;
	    for (i = NE; i >= j; i--) {
		Gauge(i, 6);
	    }
	    GPut(MX, MY, 0xFF);
	    MT = 0;
	    MY = 0;
	    return;
	}

	for (i=0; i<4; i++) {						// グローブンとオイルのヒットチェック
	    if (TX[i] == MX && TY[i] == MY && TM[i] == 0) {
		TM[i] = 10;
		for (i1=10; i1>=1; i1--) {
		    Sound(i1, 15);
		}
	    }
	}

	if (MT < 5 || MT > 34) {
	    GPut(MX, MY, 16);			// オイル小
	    return;
	}
	if (MT < 10 || MT > 29) {
	    GPut(MX, MY, 20);			// オイル中
	    return;
	}
	GPut(MX, MY, 24);			// オイル大
	return;
}

//-----------------------------------------------------------------------------------------------------------------------------
//	コインの処理
//-----------------------------------------------------------------------------------------------------------------------------
//3000
void process_coin(void) {
	unsigned char i;
	unsigned short j;
	unsigned char i1, i2;

	if (CY == 0) return;

	if (CY < 0) {
	    CY++;
	    return;
	}

	if (GA[CX][CY] > 1) return;

	switch (CT) {
	    case 0: GPut(CX, CY, 0x20); break;		// 100円コイン
	    case 1: GPut(CX, CY, 0x24); break;		// %コイン
	    case 2: GPut(CX, CY, 0x28); break;		// グローブンコイン
	    case 3: GPut(CX, CY, 0x2C); break;		// ティッ君コイン
	    case 4: GPut(CX, CY, 0x3A); break;		// 金色ブロックコイン
	    default: break;
	}

	if ((CX != X) || (CY != Y)) return;		// コインとティッ君のヒットチェック

	for (i=18; i>=13; i--) {
	    Sound(i, 200);
	}

	CY = 0;

	switch (CT) {
	    case 0:					// 100円コインなら100点追加
		add_score(10);
		break;

	    case 1:	    				// %コイン: ゲージ+200
		j = NE + 200;
		if (j > 303) j = 303;
		for (; NE <= j;  NE++) {
		    Gauge(NE, (PO == 0) ? 2 : 6);
		}
		break;

	    case 2:	    				// グローブンコイン: 
		for (i=0; i<4; i++) {
		    if (TM[i] < 1) TM[i] = -45;
		}
		CY = -45;
		break;

	    case 3:					// ティッ君コイン: 1UP
		NO++;
		Locate(35, 1); GPrintNum(NO, 2);	// 残機表示
		break;

	    case 4:					// 金色ブロックコイン: すべてのブロックが金色になる
		for (i1=3; i1<=21; i1+=2) {
		    for (i2=2; i2<=36; i2+=2) {
			if (GA[i2][i1] == 2) {
			    GPut(i2, i1, 0x63);		// 金色ブロック ノーマル
			    GA[i2  ][i1  ] = 3;
			    GA[i2+1][i1  ] = 3;
			    GA[i2  ][i1+1] = 3;
			    GA[i2+1][i1+1] = 3;
			}
		    }
		}
		break;
	}
}

//-----------------------------------------------------------------------------------------------------------------------------
//	コインの種類を決める
//-----------------------------------------------------------------------------------------------------------------------------
void select_coin(void) {
	unsigned short t;
	t = Rnd(100);
	if      (t < 50) CT = 0;
	else if (t < 75) CT = 1;
	else if (t < 90) CT = 2;
	else if (t < 97) CT = 3;
	else             CT = 4;
}

//-----------------------------------------------------------------------------------------------------------------------------
//	ミス
//-----------------------------------------------------------------------------------------------------------------------------
//4000
void miss(void) {
	unsigned char i;

	//
	// グローブンをすべて消す
	//
	for (i=0; i<4; i++) {
	    GPut(TX[i], TY[i], 0xFF);
	}

	//
	// コインを消す
	//
	if (CY > 0 && GA[CX][CY] == 0) {
	    GPut(CX, CY, 0xFF);
	}

	//
	// 得点表示を消す
	//
	if (ST > 0 && GA[SX][SY] == 0) {
	    GPut(SX, SY, 0xFF);
	}

	//
	// オイルを消す
	//
	if (MT > 0 && GA[MX][MY] == 0) {
	    GPut(MX, MY, 0xFF);
	}

	//
	// ティッ君 やられパターンを描画
	//
	GPut(X, Y, 0xEE);				// ティッ君 やられ 1
	for (i=10; i<=20; i++) Sound(i, 100);
	GPut(X, Y, 0xF2);				// ティッ君 やられ 2
	for (i=15; i<=25; i++) Sound(i, 80);
	GPut(X, Y, 0xF6);				// ティッ君 やられ 3
	for (i=20; i<=30; i++) Sound(i, 70);
	GPut(X, Y, 0xFA);				// ティッ君 やられ 4
	for (i=25; i<=35; i++) Sound(i, 60);
	GPut(X, Y, 0x00);				// ティッ君 やられ 5
	for (i=30; i<=40; i++) Sound(i, 50);
	Wait(200);
	GPut(X, Y, 0xFF);				// ティッ君消去

	NO--;
}

//-----------------------------------------------------------------------------------------------------------------------------
//	ゲームオーバー
//-----------------------------------------------------------------------------------------------------------------------------
void gameover(void) {
	unsigned char i;
	static unsigned char xy[18] = { 23,7,24,7,25,7,26,7,27,8,28,8,29,9,30,10,30,11 };
	unsigned char *p;

	Color(7);
	for (i=3; i<10; i++) {
	    Locate(2, i);
	    GPrint("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
	}
	for (i=10; i<23; i++) {
	    Locate(2, i);
	    GPrint("]]]]]]]]]]]]]]]]]]]]]]]@@@@@@@@@@@@@");
	}
	*(unsigned char *)(0xD800 + 18 + 14*40) = 0;
	Locate(8,14); GPrint("@@@@@@@@@@@");
	Locate(8,15); GPrint("@GAME@OVER@");
	Locate(8,16); GPrint("@@@@@@@@@@@");

	for (i=2; i<=21; i++) {
	    GPut(i+1, 7, 0xEE);				// ティッ君 やられ 1
	    Locate(i, 9); GPrint("\xCD\xCD\xCD\xCD");

	    Wait(150);

	    GPut(i+1, 7, 0xFF);
	    Locate(i, 9); GPrint("@");
	}

	p = &xy[0];
	for (i=0; i<=19; i++) {
	    if (i < 9) {
		X = *p++;
		Y = *p++;
	    } else {
		X = 31;
		Y = i + 3;
	    }
	    if (i < 19) {
		GPut(X, Y, 0xEE);				// ティッ君 やられ 1
	    } else {
		Locate(X, Y);
		GPrint("\xEE\xEF");
	    }
	    if (i < 14) {
		Locate(25, i+9);
		GPrint("\xCD");
	    }

	    Wait(100);

	    if (i < 19) {
		GPut(X, Y, 0xFF);				// ティッ君 やられ 1
	    } else {
		Locate(X, Y);
		GPrint("@@");
	    }
	    if (i < 13) {
		Locate(25, i+9);
		GPrint("@");
	    }
	}
	
	Wait(1500);
	NO = 4;
	*(unsigned char *)(0xD800 + 18 + 14*40) = 0x70;
}

//-----------------------------------------------------------------------------------------------------------------------------
//	タイトル画面
//-----------------------------------------------------------------------------------------------------------------------------
void clearscreen(void) {
	unsigned char i;

	Color(7);
	for (i=3; i<23; i++) {
	    Locate(2, i);
	    GPrint("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
	}
}

unsigned char title(void) {
	unsigned char i, j, a;
	unsigned char cy;

	clearscreen();

	Color(6); Locate(15,4); GPrint("\x86");		// ハートマーク
	Color(5); GPrint("@FANTIC@");
	Color(6); GPrint("\x86");

	Color(2); Locate(15,7); GPrint("HOW@TO@PLAY");
	Color(6); Locate( 3,9); GPrint("KEY@FUNCTION");
		  Locate(26,9); GPrint("SCORE@TABLE");

	GPut(18,11, 'c');				// 金色ブロック
	GPut(20,11, 'c');
	GPut(18,13, 'c');
	GPut(20,13, 'c');

	Color(2); Locate(10,11); GPrint("TICUN");
//	Locate( 8,12); GPrint("8");
//	Locate(11,14); GPrint("6");
//	Locate( 6,15); GPrint("4");
//	Locate( 9,17); GPrint("2");
	Color(6);
	Locate( 9,12); GPrint("\x82");
	Locate(11,15); GPrint("\x83");
	Locate( 6,14); GPrint("\x84");
	Locate( 8,17); GPrint("\x81");

	GPut(8, 14, 0xA7);				// ティッ君 左向き 1

	Color(7); Locate(3,19); GPrint("PRESS@SPACE");

	Locate(30, 1); GPrintNum(PA, 3);		// ROUND表示

	Color(6); Locate(15,16); GPrint("FORMATION");
	Color(5);
//	Locate(15,18); GPrint("PUSH@S@KEY");
//	Locate(16,19); GPrint("TO@START");
	Locate(18,18); GPrint("START");
	Color(2);
	Locate(18,19); GPrint("OPTION");

	GPut(26, 12, 0x87);						// グローブン 左向き 1
	Color(2); Locate(29,12); GPrint("GLOVEN");
	Color(7); Locate(28,13);
	GPrint("\xC3\xC4\xC5\xC6?\xCB\xCC\xC5\xC6");			// "50Pt～500Pt"

	GPut(26, 15, 0x20);						// 100円コイン
	Color(2); Locate(29,15); GPrint("COIN");
	Color(7); Locate(33,16); GPrint("\xC7\xC8\xC5\xC6");		// "50Pt"

	GPut(26, 18, 0x24);						// %コイン
	Color(2); Locate(29,18); GPrint("ETC");
	          Locate(32,19); GPrint("COINS");

	Color(5); Locate(2,22); GPrint("1984@");
	Color(6); GPrint("GAME@ROMAN@@");
	Color(2); GPrint("ALL@RIGHTS@RESERVED");

	cy = 0;
	Color(7); Locate(16,18); GPrint("\xCD");
	while (1) {
	    a = Inkey1();
	    if (a == 0x11 || a == 0x12) { // UP,DOWN
		Color(7);
		Locate(16,18+cy); GPrint("@");
		cy ^= 1;
		Locate(16,18+cy); GPrint("\xCD");
		Locate(18,18); Color(cy == 0 ? 5 : 2); GPrint("START");
		Locate(18,19); Color(cy == 1 ? 5 : 2); GPrint("OPTION");
	    } else
	    if (a == ' ') {
		clearscreen();
		if (cy == 0) {
		    return 0;
		}
		if (cy == 1) {
		    Option(&PA, &GM);
		    return 1;
		}
	    }
	}

	return 0;
}

//-----------------------------------------------------------------------------------------------------------------------------
//	ステージデータを展開する
//-----------------------------------------------------------------------------------------------------------------------------
void prepare_level(void) {
	unsigned char *dd, c, d;
	unsigned char i, j, k, a;

	dd = (unsigned char *)(0x3800 + (PA-1) * 45);

	k = 0;
	for (i=3; i<=21; i+=2) {
	    for (j=2; j<=36; j+=2) {
		if (k == 0) {
		    c = *dd++;
		    k = 4;
		}
		switch (c & 0xC0) {
		    case 0x00:  d = 0; a = 0xFF; break;			// 0:空白
		    case 0x40:  d = 1; a = 0x5B; break;			// 1:壁
		    case 0x80:  d = 2; a = 0x5F; break;			// 2:水色ブロック
		    case 0xC0:  d = 3; a = 0x63; break;			// 3:金色ブロック
		}
		c <<= 2;
		k--;

		GA[j  ][i  ] = d;
		GA[j+1][i  ] = d;
		GA[j  ][i+1] = d;
		GA[j+1][i+1] = d;

		GPut(j, i, a);
	    }
	}
}
